/**
 * Architektur & Implementierung von DBMS, Aufgabenblatt 7
 *
 * Bitmap Indexing, Query Processing and WAH Compression
 *
 * File        : WAHBitVector.h
 */

#ifndef WAHBITVECTOR_H
#define WAHBITVECTOR_H

#include <stdint.h>

class WAHBitVector;

/***** Global bit operations on WAHBitVectors *****/
WAHBitVector operator& (const WAHBitVector& lhs, const WAHBitVector& rhs);
WAHBitVector operator| (const WAHBitVector& lhs, const WAHBitVector& rhs);


/***** WAHBitVector class represents compressed bit vectors with WAH *****/
class WAHBitVector {
  private:
    uint32_t mSize;

  public:
    WAHBitVector(uint32_t size) 
        : mSize(size)
      {
      }

    /** number of bits */
    uint32_t size() const {
        return mSize;
    }

    /** number of 32-bit words required to store the bit vector */
    uint32_t getNumWords() const {
        /* TODO: implement this method. */
        return 0;
    }

    friend WAHBitVector operator& (const WAHBitVector& lhs, const WAHBitVector& rhs);
    friend WAHBitVector operator| (const WAHBitVector& lhs, const WAHBitVector& rhs);

    /**
     * \defgroup BitOperations Bit operation methods over the compressed bit vector.
     * @{ 
     */
    /**
     * In-place AND operator. Assumption vector lengths will be same. In-place
     * in the sense that the result will still be stored in this object although
     * internal representation is highly-likely to change, may even store the
     * result uncompressed.
     */
    WAHBitVector & operator&= (const WAHBitVector& rhs) {
        /* TODO: implement this method. */
        return *this;
    }

    /* In-place OR operator. Assumption vector lengths will be same. */
    WAHBitVector & operator|= (const WAHBitVector& rhs) {
        /* TODO: implement this method. */
        return *this;
    }

    /** Count set bits in a bit vector */
    uint32_t count() const {
        return 0;
    }
    /**@}*/

    /** 
     * When building the bitvector, this method is called to inform about the
     * next set-bit's (bit with value 1) index.
     *
     * Subsequent calls of this method must have a greater idx than the previous
     * call. 
     * 
     * @param idx Index of the next set-bit in the bitvector.
     */
    void nextSetBitIndex(uint32_t idx) {
        /* TODO: implement this method. */
    }

    /**
     * \defgroup BitIteration Iteration methods over the bits of the bit vector.
     * @{ 
     */
    void begin() {
        /* TODO: implement this method. */
    }

    /** has more bits? */
    bool hasNext() {
        /* TODO: implement this method. */
        return false;
    }

    /** return next bit, 0:false, 1:true */
    bool getNext() {
        /* TODO: implement this method. */
        return false;
    }
    /**@}*/
};

#endif /* BITVECTOR_H */
